Subject: Re: [PATCH 1/2] Remove noreturn function pointers in usage.c

From: Andi Kleen <[email-masked]>
Date: Thu, 9 Jun 2011 08:31:45 +0200

On Thu, Jun 09, 2011 at 01:52:24AM -0400, Jeff King wrote:
> On Thu, Jun 09, 2011 at 06:59:15AM +0200, Andi Kleen wrote:
> 
> > >  - Potential impact to people who do not use Gcc 4.6 with profile feedback
> > >    is not explained away well, except for "Doesn't seem to make any
> > >    difference."
> > 
> > I merely went by "there are no new warnings" (I assume that's the main
> > motivation)
> 
> On your compiler and settings, perhaps. With your patch I get:
> 
>   usage.c: In function ‘die’:
>   usage.c:70:1: error: ‘noreturn’ function does return [-Werror]

Ok.  Hmm, all I can say it compiled here.

Ok then we have to remove it. I didn't really like Junio's approach
to only do it for a single file because that would break with LTO / link
time optimization which requires declarations to match between 
translation units.

Maybe it's better to stick an extra exit() at the end to shut up
the extra warning. I'll do that I guess.

BTW 4.6.2 or so will have the problem fixed.

-Andi